## compiler

compiler

## Functions

#define | PRINTF_FMT()
#define | IS_COMPILE_CONSTANT()
#define | NON_NULL_ARGS()
#define | cpu_supports()

## Types and Values

#define | COLD
#define | NORETURN
#define | CONST_FUNCTION
#define | PURE_FUNCTION
#define | UNNEEDED
#define | NEEDED
#define | UNUSED
#define | WARN_UNUSED_RESULT
#define | WARN_DEPRECATED
#define | NO_NULL_ARGS
#define | RETURNS_NONNULL
#define | LAST_ARG_NULL

## Description

## Functions

### PRINTF_FMT()

    #define             PRINTF_FMT(nfmt, narg)

### IS_COMPILE_CONSTANT()

    #define IS_COMPILE_CONSTANT(expr) __builtin_constant_p(expr)

### NON_NULL_ARGS()

    #define NON_NULL_ARGS(...) __attribute__((__nonnull__(__VA_ARGS__)))

### cpu_supports()

    #define cpu_supports(x) __builtin_cpu_supports(x)

## Types and Values

### COLD

    #define COLD __attribute__((__cold__))

### NORETURN

    #define             NORETURN

### CONST_FUNCTION

    #define CONST_FUNCTION __attribute__((__const__))

### PURE_FUNCTION

    #define PURE_FUNCTION __attribute__((__pure__))

### UNNEEDED

    #define UNNEEDED __attribute__((__unused__))

### NEEDED

    #define NEEDED __attribute__((__used__))

### UNUSED

    #define UNUSED __attribute__((__unused__))

### WARN_UNUSED_RESULT

    #define WARN_UNUSED_RESULT __attribute__((__warn_unused_result__))

### WARN_DEPRECATED

    #define WARN_DEPRECATED __attribute__((__deprecated__))

### NO_NULL_ARGS

    #define NO_NULL_ARGS __attribute__((__nonnull__))

### RETURNS_NONNULL

    #define RETURNS_NONNULL __attribute__((__returns_nonnull__))

### LAST_ARG_NULL

    #define LAST_ARG_NULL __attribute__((__sentinel__))